/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ejb.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface Entity extends Serializable {

    public static final String ZEUS_XML_NAME = "entity";
    public static final String[] ZEUS_ATTRIBUTES = {"id"};
    public static final String[] ZEUS_ELEMENTS = {"description", "display-name", "small-icon", "large-icon", "ejb-name", "home", "remote", "local-home", "local", "ejb-class", "persistence-type", "prim-key-class", "reentrant", "cmp-version", "abstract-schema-name", "cmp-field", "primkey-field", "env-entry", "ejb-ref", "ejb-local-ref", "service-ref", "security-role-ref", "security-identity", "resource-ref", "resource-env-ref", "query"};

    public Description getDescription();

    public void setDescription(Description description);

    public DisplayName getDisplayName();

    public void setDisplayName(DisplayName displayName);

    public SmallIcon getSmallIcon();

    public void setSmallIcon(SmallIcon smallIcon);

    public LargeIcon getLargeIcon();

    public void setLargeIcon(LargeIcon largeIcon);

    public EjbName getEjbName();

    public void setEjbName(EjbName ejbName);

    public Home getHome();

    public void setHome(Home home);

    public Remote getRemote();

    public void setRemote(Remote remote);

    public LocalHome getLocalHome();

    public void setLocalHome(LocalHome localHome);

    public Local getLocal();

    public void setLocal(Local local);

    public EjbClass getEjbClass();

    public void setEjbClass(EjbClass ejbClass);

    public PersistenceType getPersistenceType();

    public void setPersistenceType(PersistenceType persistenceType);

    public PrimKeyClass getPrimKeyClass();

    public void setPrimKeyClass(PrimKeyClass primKeyClass);

    public Reentrant getReentrant();

    public void setReentrant(Reentrant reentrant);

    public CmpVersion getCmpVersion();

    public void setCmpVersion(CmpVersion cmpVersion);

    public AbstractSchemaName getAbstractSchemaName();

    public void setAbstractSchemaName(AbstractSchemaName abstractSchemaName);

    public List getCmpFieldList();

    public void setCmpFieldList(List cmpFieldList);

    public void addCmpField(CmpField cmpField);

    public void removeCmpField(CmpField cmpField);

    public PrimkeyField getPrimkeyField();

    public void setPrimkeyField(PrimkeyField primkeyField);

    public List getEnvEntryList();

    public void setEnvEntryList(List envEntryList);

    public void addEnvEntry(EnvEntry envEntry);

    public void removeEnvEntry(EnvEntry envEntry);

    public List getEjbRefList();

    public void setEjbRefList(List ejbRefList);

    public void addEjbRef(EjbRef ejbRef);

    public void removeEjbRef(EjbRef ejbRef);

    public List getEjbLocalRefList();

    public void setEjbLocalRefList(List ejbLocalRefList);

    public void addEjbLocalRef(EjbLocalRef ejbLocalRef);

    public void removeEjbLocalRef(EjbLocalRef ejbLocalRef);

    public List getServiceRefList();

    public void setServiceRefList(List serviceRefList);

    public void addServiceRef(ServiceRef serviceRef);

    public void removeServiceRef(ServiceRef serviceRef);

    public List getSecurityRoleRefList();

    public void setSecurityRoleRefList(List securityRoleRefList);

    public void addSecurityRoleRef(SecurityRoleRef securityRoleRef);

    public void removeSecurityRoleRef(SecurityRoleRef securityRoleRef);

    public SecurityIdentity getSecurityIdentity();

    public void setSecurityIdentity(SecurityIdentity securityIdentity);

    public List getResourceRefList();

    public void setResourceRefList(List resourceRefList);

    public void addResourceRef(ResourceRef resourceRef);

    public void removeResourceRef(ResourceRef resourceRef);

    public List getResourceEnvRefList();

    public void setResourceEnvRefList(List resourceEnvRefList);

    public void addResourceEnvRef(ResourceEnvRef resourceEnvRef);

    public void removeResourceEnvRef(ResourceEnvRef resourceEnvRef);

    public List getQueryList();

    public void setQueryList(List queryList);

    public void addQuery(Query query);

    public void removeQuery(Query query);

    public String getId();

    public void setId(String id);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
