/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ejb.deployment.xml;

// Global Interface Import Statements
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.Writer;

// Local Interface Import Statements
import java.util.List;
import java.io.Serializable;

public interface JonasEntity extends Serializable {

    public static final String ZEUS_XML_NAME = "jonas-entity";
    public static final String[] ZEUS_ATTRIBUTES = {};
    public static final String[] ZEUS_ELEMENTS = {"ejb-name", "jndi-name", "jonas-resource", "jonas-resource-env", "jonas-ejb-ref", "jonas-service-ref", "is-modified-method-name", "passivation-timeout", "shared", "prefetch", "max-cache-size", "min-pool-size", "cleanup", "lock-policy", "jdbc-mapping"};

    public EjbName getEjbName();

    public void setEjbName(EjbName ejbName);

    public JndiName getJndiName();

    public void setJndiName(JndiName jndiName);

    public List getJonasResourceList();

    public void setJonasResourceList(List jonasResourceList);

    public void addJonasResource(JonasResource jonasResource);

    public void removeJonasResource(JonasResource jonasResource);

    public List getJonasResourceEnvList();

    public void setJonasResourceEnvList(List jonasResourceEnvList);

    public void addJonasResourceEnv(JonasResourceEnv jonasResourceEnv);

    public void removeJonasResourceEnv(JonasResourceEnv jonasResourceEnv);

    public List getJonasEjbRefList();

    public void setJonasEjbRefList(List jonasEjbRefList);

    public void addJonasEjbRef(JonasEjbRef jonasEjbRef);

    public void removeJonasEjbRef(JonasEjbRef jonasEjbRef);

    public List getJonasServiceRefList();

    public void setJonasServiceRefList(List jonasServiceRefList);

    public void addJonasServiceRef(JonasServiceRef jonasServiceRef);

    public void removeJonasServiceRef(JonasServiceRef jonasServiceRef);

    public IsModifiedMethodName getIsModifiedMethodName();

    public void setIsModifiedMethodName(IsModifiedMethodName isModifiedMethodName);

    public PassivationTimeout getPassivationTimeout();

    public void setPassivationTimeout(PassivationTimeout passivationTimeout);

    public Shared getShared();

    public void setShared(Shared shared);

    public Prefetch getPrefetch();

    public void setPrefetch(Prefetch prefetch);

    public MaxCacheSize getMaxCacheSize();

    public void setMaxCacheSize(MaxCacheSize maxCacheSize);

    public MinPoolSize getMinPoolSize();

    public void setMinPoolSize(MinPoolSize minPoolSize);

    public Cleanup getCleanup();

    public void setCleanup(Cleanup cleanup);

    public LockPolicy getLockPolicy();

    public void setLockPolicy(LockPolicy lockPolicy);

    public JdbcMapping getJdbcMapping();

    public void setJdbcMapping(JdbcMapping jdbcMapping);

    public void marshal(File file) throws IOException;

    public void marshal(OutputStream outputStream) throws IOException;

    public void marshal(Writer writer) throws IOException;

    public void setDocType(String name, String publicID, String systemID);

    public void setOutputEncoding(String outputEncoding);

}
